#ifndef INPUT_H
#define INPUT_H

#define INPUT_HOLD_OFF 1
#define INPUT_HOLD_NORMAL 2
#define INPUT_HOLD_ALL 3

#ifndef INPUT_C
extern u8 input_hold;
extern struct input_handle *currenthandle;
extern struct input_handle *menu_input_p;
extern struct input_handle *nowplaying_input_p;
extern struct input_handle *music_input_p;
extern struct input_handle *playlist_input_p;
extern struct input_handle *playlists_input_p;
#endif

enum input_type { WHEEL, KEY, END };

struct input_handle {
	enum input_type type;
	u32 key;
	void (*callback)(void);
};

void input_handleinput(void);
void input_nowplaying_setup(int, const char *);
void input_musicmenu_setup(int, const char *);
void input_playlist(int, const char *);
void input_playlists(int, const char *);
void input_songs_setup(int, const char *);
void input_playlist_setup(int, const char *);
void input_playlists_setup(int, const char *);
void input_sound_finished();

#endif
