#include <nds.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <unistd.h>

#include <ipc2.h>

#include "file.h"
#define SOUNDC
#include "sound.h"

__attribute__((section (".ewram"))) char pcmL[2304], pcmR[2304];
enum format format;
FILE *sound_playfile;
enum state state;

void sound_setup(FILE *fp_arg, enum format format) {
	switch(format) {
		case WAVE:
			waveplay(fp_arg);
			break;

		case MAD:
			madplay(fp_arg);
			break;

		default:
			break;
	}
}

void sound_stop(void) {
	if(state == STOPPED)
		return;

	if(state != PAUSED)
		IPC_SendSync(IPC2_REQUEST_STOP_PLAYING);

	irqClear(IRQ_IPC_SYNC);

	while(IPC2->sound_state != IPC2_STOPPED);
	switch(format) {
		case WAVE:
			wave_stop();
			break;

		case MAD:
			madplay_stop();
			break;

		default:
			break;
	}

	state = STOPPED;
}

void sound_rewind(void) {
	if(IPC2->sound_state != IPC2_PLAYING)
		return;

	switch(format) {
		case WAVE:
			wave_rewind();
			break;

		default:
			break;
	}
}

void sound_forward(void) {
	if(IPC2->sound_state != IPC2_PLAYING)
		return;

	switch(format) {
		case WAVE:
			wave_forward();
			break;

		default:
			break;
	}
}

void sound_finishing(void) {
	sound_stop();
}

void sound_playpause(void) {
	switch(format) {
		case WAVE:
			wave_playpause();
			break;

		case MAD:
			madplay_playpause();
			break;
	}

	if(state == PAUSED || state == STOPPED) {
		while(IPC2->sound_state != IPC2_PLAYING);
		state = PLAYING;
	} else if(state == PLAYING) {
		while(IPC2->sound_state != IPC2_STOPPED);
		state = PAUSED;
	}
}
